package io.dekorate.servicecatalog.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ParameterBuilder extends ParameterFluentImpl<ParameterBuilder> implements VisitableBuilder<io.dekorate.servicecatalog.config.Parameter,ParameterBuilder>{

    ParameterFluent<?> fluent;
    Boolean validationEnabled;

    public ParameterBuilder(){
            this(true);
    }
    public ParameterBuilder(Boolean validationEnabled){
            this(new Parameter(), validationEnabled);
    }
    public ParameterBuilder(ParameterFluent<?> fluent){
            this(fluent, true);
    }
    public ParameterBuilder(ParameterFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Parameter(), validationEnabled);
    }
    public ParameterBuilder(ParameterFluent<?> fluent,io.dekorate.servicecatalog.config.Parameter instance){
            this(fluent, instance, true);
    }
    public ParameterBuilder(ParameterFluent<?> fluent,io.dekorate.servicecatalog.config.Parameter instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withKey(instance.getKey()); 
            fluent.withValue(instance.getValue()); 
            this.validationEnabled = validationEnabled; 
    }
    public ParameterBuilder(io.dekorate.servicecatalog.config.Parameter instance){
            this(instance,true);
    }
    public ParameterBuilder(io.dekorate.servicecatalog.config.Parameter instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withKey(instance.getKey()); 
            this.withValue(instance.getValue()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableParameter build(){
            EditableParameter buildable = new EditableParameter(fluent.getKey(),fluent.getValue());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ParameterBuilder that = (ParameterBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
